---
product: "AG Grid"
title: "Printing"
description: "This section explains how to use the Print Layout feature of the grid."
framework: javascript
version: "36.2.0"
related:
    - title: "CSV Export"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/csv-export/"
    - title: "Excel Export"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export/"
    - title: "Excel Import"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-import/"
    - title: "PDF Export"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/pdf-export/"
    - title: "Clipboard"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/clipboard/"
    - title: "Drag & Drop"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/drag-and-drop/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Printing

This section explains how to use the Print Layout feature of the grid.

A grid using print layout will not use any scrollbars so all rows and columns will get printed. The grid will auto-size width and height to fit all contents. This means if the grid is printed on paper all the cells will get included, as opposed to printing a grid with scrollbars and only cells within the visible area will get printed.

The example below shows print layout. The following can be noted:

- Pressing the button 'Printer Friendly Layout' turns the grid into print layout and removes all scrolls.
- Pressing the button 'Normal Layout' returns the grid back to normal.

#### For Print Simple

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

const columnDefs: ColDef[] = [
  {
    headerName: "ID",
    valueGetter: "node.rowIndex + 1",
    width: 70,
    pinned: "left",
  },
  { field: "model" },
  { field: "color" },
  { field: "price", valueFormatter: '"$" + value.toLocaleString()' },
  { field: "year" },
  { field: "country" },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: columnDefs,
  rowData: getData(),
  defaultColDef: {
    width: 150,
  },
};

function onBtPrinterFriendly() {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "";
  eGridDiv.style.height = "";

  gridApi!.setGridOption("domLayout", "print");
}

function onBtNormal() {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "400px";
  eGridDiv.style.height = "200px";

  // Same as setting to 'normal' as it is the default
  gridApi!.setGridOption("domLayout", undefined);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtPrinterFriendly = onBtPrinterFriendly;
  (<any>window).onBtNormal = onBtNormal;
}
```

[Live example: For Print Simple](https://www.ag-grid.com/archive/36.2.0/examples/printing/for-print-simple/typescript/)

## Toggling Print Layout

Print layout can be turned on by setting the property `domLayout='print'` or by calling the grid API `setGridOption('domLayout', 'print')`. Similarly the layout can be set back to normal by unsetting the `domLayout` property or calling the grid API `setGridOption('domLayout', null)`.

```js
// setting the grid layout to 'print'
api.setGridOption('domLayout', 'print');

// resetting the layout back to normal
api.setGridOption('domLayout', undefined);
```

## Toggling Grid Size

The grid width and height will adjust automatically to fit the contents of all cells. For this to work the application should **not** set a width or height onto the grid component. If using print layout, make sure you have no width or height set for the grid.

All the examples on this page set width and height initially on the grid and then remove the width and height when print layout is set.

## Page Break

When in print layout all rows will have the CSS property `page-break-inside: avoid` so rows will not be split across pages (eg the top half of the row on one printed page with the other half on the next printed page).

## Detailed Printing Example

Below shows a more detailed example and also automatically shows the print dialog. From the example, the following can be noted:

- When 'Print' is pressed, the grid will do the following:
  - Set the grid into print layout.
  - Remove the height and width settings from the grid to allow the grid to auto-fit it's size.
  - Wait for two seconds (to allow the browser to redraw with the new settings) and then bring up the print dialog.
  - Set the grid back to normal when the print dialog is closed.
- The first column 'ID' is pinned. When in print layout, the column is not pinned as pinning makes no sense when there are no horizontal scrolls.
- The data is grouped and the group row spans the width of the grid. This group row is included in print layout as normal.

#### For Print Complex

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClientSideRowModelApiModule,
  RowGroupingModule,
]);

let gridApi: GridApi;
const columnDefs: ColDef[] = [
  { field: "group", rowGroup: true, hide: true },
  { field: "id", pinned: "left", width: 70 },
  { field: "model", width: 180 },
  { field: "color", width: 100 },
  {
    field: "price",
    valueFormatter: ({ value }: ValueFormatterParams) =>
      typeof value === "number" && !Number.isNaN(value)
        ? `$${value.toLocaleString()}`
        : "",
    width: 100,
  },
  { field: "year", width: 100 },
  { field: "country", width: 120 },
];

const gridOptions: GridOptions = {
  columnDefs: columnDefs,
  rowData: getData(),
  groupDisplayType: "groupRows",
  onFirstDataRendered: onFirstDataRendered,
};

function onFirstDataRendered(params: FirstDataRenderedEvent) {
  params.api.expandAll();
}

function onBtPrint() {
  setPrinterFriendly(gridApi);

  setTimeout(() => {
    print();
    setNormal(gridApi);
  }, 2000);
}

function setPrinterFriendly(api: GridApi) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "";
  eGridDiv.style.height = "";
  api.setGridOption("domLayout", "print");
}

function setNormal(api: GridApi) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "700px";
  eGridDiv.style.height = "200px";

  api.setGridOption("domLayout", undefined);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtPrint = onBtPrint;
}
```

[Live example: For Print Complex](https://www.ag-grid.com/archive/36.2.0/examples/printing/for-print-complex/typescript/)

## Animations & Redraw

When the grid is in print layout, the grid does **not** use absolute positioning for the rows, rather the rows are laid out using normal flow. In other words normally the grid places each row using exact pixel positioning - this makes things such as row animation possible where the grid moves the row by changing absolute pixel position and uses CSS transition for the row to animate to the new location. This happens usually after filtering or sorting. When in print mode, the rows are laid out in the order they appear in the dom - this makes things such as page breaks possible but removes the possibility of animations.

When in print layout the grid will redraw the entire grid any time there is a change to the rows. If just one row is added / removed, or a filter or sort is applied, the entire DOM is removed and all rows are inserted again from top to bottom. This makes print layout best for non-interactive grids (ie for printing) as you will lose animations and changes to the grid will be expensive (the grid redraws everything on every change).

## Don't Print Large Data

Do not use this technique for printing if you are showing a large number of rows or columns. This is not a problem with the grid, it is a limitation on browsers on how much data they can easily display in one web page. If you try to render lots of data into the web page, the web page will create lots of DOM elements and will either slow things down or simply hang the browser. AG Grid gets around this problem by virtualising the rows and columns. However if you render the whole grid, there is no possibility of virtualising the rows or columns.

If you want to allow printing large data sets it's best to get your users to export to CSV or Excel and then print from another non-web based application.

## Keep Print Layout for Print Only

When the grid is in print layout, it will be rendering all cells without using row virtualisation. This means that the grid will be slower given the amount of DOM it is rendering. Only use print layout when you actually want to print. All of the functions (filtering, sorting, dragging columns etc) will work, however the performance will be impacted if the data set is large and will frustrate your users. For this reason it's best keeping print layout for printing only and normal (or auto-height) layout at all other times.

## Row Models

The only [Row Model](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-models/) that print layout works with is the default [Client Side](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-models/#client-side) row model. It will not work with the others ([Infinite](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/infinite-scrolling/), [Server-Side](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/server-side-model/) or [Viewport](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/viewport/)). This is because the grid will render the entire data-set which goes against the philosophy of the other row models which lazy load data.


---
product: "AG Grid"
title: "Printing"
description: "This section explains how to use the Print Layout feature of the grid."
framework: angular
version: "36.2.0"
related:
    - title: "CSV Export"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/csv-export/"
    - title: "Excel Export"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export/"
    - title: "Excel Import"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-import/"
    - title: "PDF Export"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/pdf-export/"
    - title: "Clipboard"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/clipboard/"
    - title: "Drag & Drop"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/drag-and-drop/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Printing

This section explains how to use the Print Layout feature of the grid.

A grid using print layout will not use any scrollbars so all rows and columns will get printed. The grid will auto-size width and height to fit all contents. This means if the grid is printed on paper all the cells will get included, as opposed to printing a grid with scrollbars and only cells within the visible area will get printed.

The example below shows print layout. The following can be noted:

- Pressing the button 'Printer Friendly Layout' turns the grid into print layout and removes all scrolls.
- Pressing the button 'Normal Layout' returns the grid back to normal.

#### For Print Simple

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<button (click)="onBtPrinterFriendly()">
      Printer Friendly Layout
    </button>
    <button (click)="onBtNormal()">Normal Layout</button>

    <ag-grid-angular
      id="myGrid"
      style="width: 400px; height: 200px;"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      [defaultColDef]="defaultColDef"
      (gridReady)="onGridReady($event)"
    />

    <div style="border: 10px solid #eee; padding: 10px; margin-top: 20px">
      <p style="text-align: center">
        This text is under the grid and should move up and down as the height of
        the grid changes.
      </p>
    </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    {
      headerName: "ID",
      valueGetter: "node.rowIndex + 1",
      width: 70,
      pinned: "left",
    },
    { field: "model" },
    { field: "color" },
    { field: "price", valueFormatter: '"$" + value.toLocaleString()' },
    { field: "year" },
    { field: "country" },
  ];
  rowData: any[] | null = getData();
  defaultColDef: ColDef = {
    width: 150,
  };

  onBtPrinterFriendly() {
    const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
    eGridDiv.style.width = "";
    eGridDiv.style.height = "";
    this.gridApi.setGridOption("domLayout", "print");
  }

  onBtNormal() {
    const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
    eGridDiv.style.width = "400px";
    eGridDiv.style.height = "200px";
    // Same as setting to 'normal' as it is the default
    this.gridApi.setGridOption("domLayout", undefined);
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}
```

[Live example: For Print Simple](https://www.ag-grid.com/archive/36.2.0/examples/printing/for-print-simple/angular/)

## Toggling Print Layout

Print layout can be turned on by setting the property `domLayout='print'` or by calling the grid API `setGridOption('domLayout', 'print')`. Similarly the layout can be set back to normal by unsetting the `domLayout` property or calling the grid API `setGridOption('domLayout', null)`.

```ts
// setting the grid layout to 'print'
this.gridApi.setGridOption('domLayout', 'print');

// resetting the layout back to normal
this.gridApi.setGridOption('domLayout', undefined);
```

## Toggling Grid Size

The grid width and height will adjust automatically to fit the contents of all cells. For this to work the application should **not** set a width or height onto the grid component. If using print layout, make sure you have no width or height set for the grid.

All the examples on this page set width and height initially on the grid and then remove the width and height when print layout is set.

## Page Break

When in print layout all rows will have the CSS property `page-break-inside: avoid` so rows will not be split across pages (eg the top half of the row on one printed page with the other half on the next printed page).

## Detailed Printing Example

Below shows a more detailed example and also automatically shows the print dialog. From the example, the following can be noted:

- When 'Print' is pressed, the grid will do the following:
  - Set the grid into print layout.
  - Remove the height and width settings from the grid to allow the grid to auto-fit it's size.
  - Wait for two seconds (to allow the browser to redraw with the new settings) and then bring up the print dialog.
  - Set the grid back to normal when the print dialog is closed.
- The first column 'ID' is pinned. When in print layout, the column is not pinned as pinning makes no sense when there are no horizontal scrolls.
- The data is grouped and the group row spans the width of the grid. This group row is included in print layout as normal.

#### For Print Complex

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowGroupingDisplayType,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClientSideRowModelApiModule,
  RowGroupingModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<button (click)="onBtPrint()">Print</button>

    <ag-grid-angular
      id="myGrid"
      style="width: 700px; height: 200px;"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      [groupDisplayType]="groupDisplayType"
      (firstDataRendered)="onFirstDataRendered($event)"
      (gridReady)="onGridReady($event)"
    />

    <div style="border: 10px solid #eee; padding: 10px; margin-top: 20px">
      <p style="text-align: center">
        This text is under the grid and should move up and down as the height of
        the grid changes.
      </p>
    </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { field: "group", rowGroup: true, hide: true },
    { field: "id", pinned: "left", width: 70 },
    { field: "model", width: 180 },
    { field: "color", width: 100 },
    {
      field: "price",
      valueFormatter: ({ value }: ValueFormatterParams) =>
        typeof value === "number" && !Number.isNaN(value)
          ? `$${value.toLocaleString()}`
          : "",
      width: 100,
    },
    { field: "year", width: 100 },
    { field: "country", width: 120 },
  ];
  rowData: any[] | null = getData();
  groupDisplayType: RowGroupingDisplayType = "groupRows";

  onFirstDataRendered(params: FirstDataRenderedEvent) {
    params.api.expandAll();
  }

  onBtPrint() {
    setPrinterFriendly(this.gridApi);
    setTimeout(() => {
      print();
      setNormal(this.gridApi);
    }, 2000);
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

function setPrinterFriendly(api: GridApi) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "";
  eGridDiv.style.height = "";
  api.setGridOption("domLayout", "print");
}
function setNormal(api: GridApi) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "700px";
  eGridDiv.style.height = "200px";
  api.setGridOption("domLayout", undefined);
}
```

[Live example: For Print Complex](https://www.ag-grid.com/archive/36.2.0/examples/printing/for-print-complex/angular/)

## Animations & Redraw

When the grid is in print layout, the grid does **not** use absolute positioning for the rows, rather the rows are laid out using normal flow. In other words normally the grid places each row using exact pixel positioning - this makes things such as row animation possible where the grid moves the row by changing absolute pixel position and uses CSS transition for the row to animate to the new location. This happens usually after filtering or sorting. When in print mode, the rows are laid out in the order they appear in the dom - this makes things such as page breaks possible but removes the possibility of animations.

When in print layout the grid will redraw the entire grid any time there is a change to the rows. If just one row is added / removed, or a filter or sort is applied, the entire DOM is removed and all rows are inserted again from top to bottom. This makes print layout best for non-interactive grids (ie for printing) as you will lose animations and changes to the grid will be expensive (the grid redraws everything on every change).

## Don't Print Large Data

Do not use this technique for printing if you are showing a large number of rows or columns. This is not a problem with the grid, it is a limitation on browsers on how much data they can easily display in one web page. If you try to render lots of data into the web page, the web page will create lots of DOM elements and will either slow things down or simply hang the browser. AG Grid gets around this problem by virtualising the rows and columns. However if you render the whole grid, there is no possibility of virtualising the rows or columns.

If you want to allow printing large data sets it's best to get your users to export to CSV or Excel and then print from another non-web based application.

## Keep Print Layout for Print Only

When the grid is in print layout, it will be rendering all cells without using row virtualisation. This means that the grid will be slower given the amount of DOM it is rendering. Only use print layout when you actually want to print. All of the functions (filtering, sorting, dragging columns etc) will work, however the performance will be impacted if the data set is large and will frustrate your users. For this reason it's best keeping print layout for printing only and normal (or auto-height) layout at all other times.

## Row Models

The only [Row Model](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-models/) that print layout works with is the default [Client Side](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-models/#client-side) row model. It will not work with the others ([Infinite](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/infinite-scrolling/), [Server-Side](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/server-side-model/) or [Viewport](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/viewport/)). This is because the grid will render the entire data-set which goes against the philosophy of the other row models which lazy load data.


---
product: "AG Grid"
title: "Printing"
description: "This section explains how to use the Print Layout feature of the grid."
framework: vue
version: "36.2.0"
related:
    - title: "CSV Export"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/csv-export/"
    - title: "Excel Export"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export/"
    - title: "Excel Import"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-import/"
    - title: "PDF Export"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/pdf-export/"
    - title: "Clipboard"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/clipboard/"
    - title: "Drag & Drop"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/drag-and-drop/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Printing

This section explains how to use the Print Layout feature of the grid.

A grid using print layout will not use any scrollbars so all rows and columns will get printed. The grid will auto-size width and height to fit all contents. This means if the grid is printed on paper all the cells will get included, as opposed to printing a grid with scrollbars and only cells within the visible area will get printed.

The example below shows print layout. The following can be noted:

- Pressing the button 'Printer Friendly Layout' turns the grid into print layout and removes all scrolls.
- Pressing the button 'Normal Layout' returns the grid back to normal.

#### For Print Simple

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <button v-on:click="onBtPrinterFriendly()">Printer Friendly Layout</button>
    <button v-on:click="onBtNormal()">Normal Layout</button>
    <ag-grid-vue
      id="myGrid"
      style="width: 400px; height: 200px;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :rowData="rowData"
      :defaultColDef="defaultColDef"></ag-grid-vue>
      <div style="border: 10px solid #eee; padding: 10px; margin-top: 20px">
        <p style="text-align: center">
          This text is under the grid and should move up and down as the height of the grid changes.
        </p>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "ID",
        valueGetter: "node.rowIndex + 1",
        width: 70,
        pinned: "left",
      },
      { field: "model" },
      { field: "color" },
      { field: "price", valueFormatter: '"$" + value.toLocaleString()' },
      { field: "year" },
      { field: "country" },
    ]);
    const rowData = ref<any[] | null>(getData());
    const defaultColDef = ref<ColDef>({
      width: 150,
    });

    function onBtPrinterFriendly() {
      const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
      eGridDiv.style.width = "";
      eGridDiv.style.height = "";
      gridApi.value!.setGridOption("domLayout", "print");
    }
    function onBtNormal() {
      const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
      eGridDiv.style.width = "400px";
      eGridDiv.style.height = "200px";
      // Same as setting to 'normal' as it is the default
      gridApi.value!.setGridOption("domLayout", undefined);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      defaultColDef,
      onGridReady,
      onBtPrinterFriendly,
      onBtNormal,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: For Print Simple](https://www.ag-grid.com/archive/36.2.0/examples/printing/for-print-simple/vue3/)

## Toggling Print Layout

Print layout can be turned on by setting the property `domLayout='print'` or by calling the grid API `setGridOption('domLayout', 'print')`. Similarly the layout can be set back to normal by unsetting the `domLayout` property or calling the grid API `setGridOption('domLayout', null)`.

```ts
// setting the grid layout to 'print'
this.gridApi.setGridOption('domLayout', 'print');

// resetting the layout back to normal
this.gridApi.setGridOption('domLayout', undefined);
```

## Toggling Grid Size

The grid width and height will adjust automatically to fit the contents of all cells. For this to work the application should **not** set a width or height onto the grid component. If using print layout, make sure you have no width or height set for the grid.

All the examples on this page set width and height initially on the grid and then remove the width and height when print layout is set.

## Page Break

When in print layout all rows will have the CSS property `page-break-inside: avoid` so rows will not be split across pages (eg the top half of the row on one printed page with the other half on the next printed page).

## Detailed Printing Example

Below shows a more detailed example and also automatically shows the print dialog. From the example, the following can be noted:

- When 'Print' is pressed, the grid will do the following:
  - Set the grid into print layout.
  - Remove the height and width settings from the grid to allow the grid to auto-fit it's size.
  - Wait for two seconds (to allow the browser to redraw with the new settings) and then bring up the print dialog.
  - Set the grid back to normal when the print dialog is closed.
- The first column 'ID' is pinned. When in print layout, the column is not pinned as pinning makes no sense when there are no horizontal scrolls.
- The data is grouped and the group row spans the width of the grid. This group row is included in print layout as normal.

#### For Print Complex

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowGroupingDisplayType,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClientSideRowModelApiModule,
  RowGroupingModule,
]);

function setPrinterFriendly(api: GridApi) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "";
  eGridDiv.style.height = "";
  api.setGridOption("domLayout", "print");
}

function setNormal(api: GridApi) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "700px";
  eGridDiv.style.height = "200px";
  api.setGridOption("domLayout", undefined);
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <button v-on:click="onBtPrint()">Print</button>
    <ag-grid-vue
      id="myGrid"
      style="width: 700px; height: 200px;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :rowData="rowData"
      :groupDisplayType="groupDisplayType"
      @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
      <div style="border: 10px solid #eee; padding: 10px; margin-top: 20px">
        <p style="text-align: center">
          This text is under the grid and should move up and down as the height of the grid changes.
        </p>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "group", rowGroup: true, hide: true },
      { field: "id", pinned: "left", width: 70 },
      { field: "model", width: 180 },
      { field: "color", width: 100 },
      {
        field: "price",
        valueFormatter: ({ value }: ValueFormatterParams) =>
          typeof value === "number" && !Number.isNaN(value)
            ? `$${value.toLocaleString()}`
            : "",
        width: 100,
      },
      { field: "year", width: 100 },
      { field: "country", width: 120 },
    ]);
    const rowData = ref<any[] | null>(getData());
    const groupDisplayType = ref<RowGroupingDisplayType>("groupRows");

    function onFirstDataRendered(params: FirstDataRenderedEvent) {
      params.api.expandAll();
    }
    function onBtPrint() {
      setPrinterFriendly(gridApi.value);
      setTimeout(() => {
        print();
        setNormal(gridApi.value);
      }, 2000);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      groupDisplayType,
      onGridReady,
      onFirstDataRendered,
      onBtPrint,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: For Print Complex](https://www.ag-grid.com/archive/36.2.0/examples/printing/for-print-complex/vue3/)

## Animations & Redraw

When the grid is in print layout, the grid does **not** use absolute positioning for the rows, rather the rows are laid out using normal flow. In other words normally the grid places each row using exact pixel positioning - this makes things such as row animation possible where the grid moves the row by changing absolute pixel position and uses CSS transition for the row to animate to the new location. This happens usually after filtering or sorting. When in print mode, the rows are laid out in the order they appear in the dom - this makes things such as page breaks possible but removes the possibility of animations.

When in print layout the grid will redraw the entire grid any time there is a change to the rows. If just one row is added / removed, or a filter or sort is applied, the entire DOM is removed and all rows are inserted again from top to bottom. This makes print layout best for non-interactive grids (ie for printing) as you will lose animations and changes to the grid will be expensive (the grid redraws everything on every change).

## Don't Print Large Data

Do not use this technique for printing if you are showing a large number of rows or columns. This is not a problem with the grid, it is a limitation on browsers on how much data they can easily display in one web page. If you try to render lots of data into the web page, the web page will create lots of DOM elements and will either slow things down or simply hang the browser. AG Grid gets around this problem by virtualising the rows and columns. However if you render the whole grid, there is no possibility of virtualising the rows or columns.

If you want to allow printing large data sets it's best to get your users to export to CSV or Excel and then print from another non-web based application.

## Keep Print Layout for Print Only

When the grid is in print layout, it will be rendering all cells without using row virtualisation. This means that the grid will be slower given the amount of DOM it is rendering. Only use print layout when you actually want to print. All of the functions (filtering, sorting, dragging columns etc) will work, however the performance will be impacted if the data set is large and will frustrate your users. For this reason it's best keeping print layout for printing only and normal (or auto-height) layout at all other times.

## Row Models

The only [Row Model](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-models/) that print layout works with is the default [Client Side](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-models/#client-side) row model. It will not work with the others ([Infinite](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/infinite-scrolling/), [Server-Side](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/server-side-model/) or [Viewport](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/viewport/)). This is because the grid will render the entire data-set which goes against the philosophy of the other row models which lazy load data.


---
product: "AG Grid"
title: "Printing"
description: "This section explains how to use the Print Layout feature of the grid."
framework: react
version: "36.2.0"
related:
    - title: "CSV Export"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/csv-export/"
    - title: "Excel Export"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export/"
    - title: "Excel Import"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-import/"
    - title: "PDF Export"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/pdf-export/"
    - title: "Clipboard"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/clipboard/"
    - title: "Drag & Drop"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/drag-and-drop/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Printing

This section explains how to use the Print Layout feature of the grid.

A grid using print layout will not use any scrollbars so all rows and columns will get printed. The grid will auto-size width and height to fit all contents. This means if the grid is printed on paper all the cells will get included, as opposed to printing a grid with scrollbars and only cells within the visible area will get printed.

The example below shows print layout. The following can be noted:

- Pressing the button 'Printer Friendly Layout' turns the grid into print layout and removes all scrolls.
- Pressing the button 'Normal Layout' returns the grid back to normal.

#### For Print Simple

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "200px", width: "400px" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "ID",
      valueGetter: "node.rowIndex + 1",
      width: 70,
      pinned: "left",
    },
    { field: "model" },
    { field: "color" },
    { field: "price", valueFormatter: '"$" + value.toLocaleString()' },
    { field: "year" },
    { field: "country" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 150,
    };
  }, []);

  const onBtPrinterFriendly = useCallback(() => {
    const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
    eGridDiv.style.width = "";
    eGridDiv.style.height = "";
    gridRef.current!.api.setGridOption("domLayout", "print");
  }, []);

  const onBtNormal = useCallback(() => {
    const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
    eGridDiv.style.width = "400px";
    eGridDiv.style.height = "200px";
    // Same as setting to 'normal' as it is the default
    gridRef.current!.api.setGridOption("domLayout", undefined);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <button onClick={onBtPrinterFriendly}>Printer Friendly Layout</button>
        <button onClick={onBtNormal}>Normal Layout</button>

        <div id="myGrid" style={gridStyle}>
          <AgGridReact
            ref={gridRef}
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>

        <div
          style={{
            border: "10px solid #eee",
            padding: "10px",
            marginTop: "20px",
          }}
        >
          <p style={{ textAlign: "center" }}>
            This text is under the grid and should move up and down as the
            height of the grid changes.
          </p>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: For Print Simple](https://www.ag-grid.com/archive/36.2.0/examples/printing/for-print-simple/reactFunctionalTs/)

## Toggling Print Layout

Print layout can be turned on by setting the property `domLayout='print'` or by calling the grid API `setGridOption('domLayout', 'print')`. Similarly the layout can be set back to normal by unsetting the `domLayout` property or calling the grid API `setGridOption('domLayout', null)`.

```jsx
// setting the grid layout to 'print'
gridApi.setGridOption('domLayout', 'print');

// resetting the layout back to normal
gridApi.setGridOption('domLayout', undefined);
```

## Toggling Grid Size

The grid width and height will adjust automatically to fit the contents of all cells. For this to work the application should **not** set a width or height onto the grid component. If using print layout, make sure you have no width or height set for the grid.

All the examples on this page set width and height initially on the grid and then remove the width and height when print layout is set.

## Page Break

When in print layout all rows will have the CSS property `page-break-inside: avoid` so rows will not be split across pages (eg the top half of the row on one printed page with the other half on the next printed page).

## Detailed Printing Example

Below shows a more detailed example and also automatically shows the print dialog. From the example, the following can be noted:

- When 'Print' is pressed, the grid will do the following:
  - Set the grid into print layout.
  - Remove the height and width settings from the grid to allow the grid to auto-fit it's size.
  - Wait for two seconds (to allow the browser to redraw with the new settings) and then bring up the print dialog.
  - Set the grid back to normal when the print dialog is closed.
- The first column 'ID' is pinned. When in print layout, the column is not pinned as pinning makes no sense when there are no horizontal scrolls.
- The data is grouped and the group row spans the width of the grid. This group row is included in print layout as normal.

#### For Print Complex

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowGroupingDisplayType,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ClientSideRowModelApiModule,
  RowGroupingModule,
];

function setPrinterFriendly(api: GridApi) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "";
  eGridDiv.style.height = "";
  api.setGridOption("domLayout", "print");
}

function setNormal(api: GridApi) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.width = "700px";
  eGridDiv.style.height = "200px";
  api.setGridOption("domLayout", undefined);
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "200px", width: "700px" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "group", rowGroup: true, hide: true },
    { field: "id", pinned: "left", width: 70 },
    { field: "model", width: 180 },
    { field: "color", width: 100 },
    {
      field: "price",
      valueFormatter: ({ value }: ValueFormatterParams) =>
        typeof value === "number" && !Number.isNaN(value)
          ? `$${value.toLocaleString()}`
          : "",
      width: 100,
    },
    { field: "year", width: 100 },
    { field: "country", width: 120 },
  ]);

  const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
    params.api.expandAll();
  }, []);

  const onBtPrint = useCallback(() => {
    setPrinterFriendly(gridRef.current!.api);
    setTimeout(() => {
      print();
      setNormal(gridRef.current!.api);
    }, 2000);
  }, [print]);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <button onClick={onBtPrint}>Print</button>

        <div id="myGrid" style={gridStyle}>
          <AgGridReact
            ref={gridRef}
            rowData={rowData}
            columnDefs={columnDefs}
            groupDisplayType={"groupRows"}
            onFirstDataRendered={onFirstDataRendered}
          />
        </div>

        <div
          style={{
            border: "10px solid #eee",
            padding: "10px",
            marginTop: "20px",
          }}
        >
          <p style={{ textAlign: "center" }}>
            This text is under the grid and should move up and down as the
            height of the grid changes.
          </p>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: For Print Complex](https://www.ag-grid.com/archive/36.2.0/examples/printing/for-print-complex/reactFunctionalTs/)

## Animations & Redraw

When the grid is in print layout, the grid does **not** use absolute positioning for the rows, rather the rows are laid out using normal flow. In other words normally the grid places each row using exact pixel positioning - this makes things such as row animation possible where the grid moves the row by changing absolute pixel position and uses CSS transition for the row to animate to the new location. This happens usually after filtering or sorting. When in print mode, the rows are laid out in the order they appear in the dom - this makes things such as page breaks possible but removes the possibility of animations.

When in print layout the grid will redraw the entire grid any time there is a change to the rows. If just one row is added / removed, or a filter or sort is applied, the entire DOM is removed and all rows are inserted again from top to bottom. This makes print layout best for non-interactive grids (ie for printing) as you will lose animations and changes to the grid will be expensive (the grid redraws everything on every change).

## Don't Print Large Data

Do not use this technique for printing if you are showing a large number of rows or columns. This is not a problem with the grid, it is a limitation on browsers on how much data they can easily display in one web page. If you try to render lots of data into the web page, the web page will create lots of DOM elements and will either slow things down or simply hang the browser. AG Grid gets around this problem by virtualising the rows and columns. However if you render the whole grid, there is no possibility of virtualising the rows or columns.

If you want to allow printing large data sets it's best to get your users to export to CSV or Excel and then print from another non-web based application.

## Keep Print Layout for Print Only

When the grid is in print layout, it will be rendering all cells without using row virtualisation. This means that the grid will be slower given the amount of DOM it is rendering. Only use print layout when you actually want to print. All of the functions (filtering, sorting, dragging columns etc) will work, however the performance will be impacted if the data set is large and will frustrate your users. For this reason it's best keeping print layout for printing only and normal (or auto-height) layout at all other times.

## Row Models

The only [Row Model](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-models/) that print layout works with is the default [Client Side](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-models/#client-side) row model. It will not work with the others ([Infinite](https://www.ag-grid.com/archive/36.2.0/react-data-grid/infinite-scrolling/), [Server-Side](https://www.ag-grid.com/archive/36.2.0/react-data-grid/server-side-model/) or [Viewport](https://www.ag-grid.com/archive/36.2.0/react-data-grid/viewport/)). This is because the grid will render the entire data-set which goes against the philosophy of the other row models which lazy load data.
